/* Assembler for LALU (ASM2.C) by M. Mruzek, 2023 */
/* ASM2.C version is introduction of Labels 11/13/23 */ 
/* ASM3.C has working labels for Jumps 11/16/23 */         
/* ASM4.C is first use of variable names 11/16/23 */
/* ASM5.C used half addresses for < and > 11/27/23 */
/* ASM6.C fixed major bug with string array compares */ 
/* ASM7.C increased line, label, variable limits 11/30/23 */
/* ASM8.C increased line limits (Shorter Lines) 12/13/23 */
/* ASM9.C increased labels and variables 200 each 1/22/24 */
/* Note: Remove comments from source.txt before assembly! */
#include <stdio.h>
#include <string.h>
#include <stdlib.h> 
main()
{        /* Start of Main */ 
         int lnum=0, cnum=0, c, i, j; /* line & character numbers */
         int ltot, l, v, m, n, k;     /* various integer variables */
         FILE *rom, *code;            /* rom is output, code input */
         char lines[3498][6];         /* 2D char array 3498 lines */
         char op[3], s[2], byte;      /* Variable to hold opcode text */      
         char label[200][4],temp;     /* 100 labels of 4 characters */ 
         int index=0,intot=0,blank=0; /* index, index total, blanks */  
         int labad[200], a, b, jp[3]; /* Eventually the byte count */ 
         int varad[200],vindex=0;     /* Variable search and store */   
         int vt[3], vp[3];            /* Variable use */ 
         char varia[200][4];          /* 100 variables of 4 characters */          
         int jt[3], flag, vatot;      /* Temporary for compares */ 
         for(i=0;i<3498;i++){         /* Initialize array with blanks */     
                   for(j=0;j<6;j++){
                             lines[i][j]=32;
                   }
         }
         /* Open input and output files. Files in directory!  */
         rom=fopen("rom.bin", "r+b");   /* R/W binary   */   
         if(rom == NULL){printf("Error opening rom.bin");}     
         code=fopen("source.txt", "r"); /* R only text  */
         if(code == NULL){printf("Error opening source.txt");}
         /* Stop for EOF. Skip past comment semi-colon  */
         while ((c=getc(code)) != EOF) {  /* Reads 1st char here */                 
         if (c==59){   /* 59 is semi-colon indicating comment */
         while ((c=getc(code)) != 10) {   /* Must find "10' to stop */
         cnum++;
         } /* Skips forward when a semi-colon is encountered anywhere */
         } /* End of skipping forward */
         /* Test for new line, otherwise store the character   */
         if (c==10){           /* Character returned for new line */      
         lines[lnum][cnum]=c;  /* So Parser can detect new line   */       
         lnum++;               /* Increment line number */
         cnum=0;               /* Reset to first character in new line */
         }
         else{
         lines[lnum][cnum]=c; /* Store character in current line */
         cnum++;              /* Increment character number */
         }
         }
         ltot=lnum;           /* Save number of lines for parsing */                      
         /* End of parsing source text and storing in lines */ 
         printf("lines=  %d\n", ltot);
         /* Scan lines in memory looking for Labels (ie ":LAB") */   
         for(l=0;l<(ltot+1);l++){ /* +1 gets last line */  
         if(lines[l][0]==':'){label[index][0]=lines[l][1];
                              label[index][1]=lines[l][2];
                              label[index][2]=lines[l][3];
                              labad[index]=l; /* Assumes l#=bytes! */
                              index++;}}
         printf("Total of %d labels found \n", index); 
         intot=index;  /* Use when searching for labels */                 

         /* Scan line in memory looking for Variables (ie $VAR) */
         /* Place all variable declarations at end of source! */     
         for(l=0;l<(ltot+1);l++){ /* +1 gets last line */
         if(lines[l][0]=='$'){varia[vindex][0]=lines[l][1]; 
                              varia[vindex][1]=lines[l][2]; 
                              varia[vindex][2]=lines[l][3];
                              varad[vindex]=65280 + vindex;
                              vindex++;}} /* FF00 + vindex */
         printf("Total number variables is %d \n", vindex);
         vatot=vindex; /* Use for searching variables */

         /* Compare opcode strings and translate to machine hex */
         for(l=0;l<ltot;l++){ byte=0xFF; /* Use for error test  */        
         op[0]=lines[l][0];op[1]=lines[l][1];op[2]=lines[l][2];
         /* List of stand-alone mnemonics...put x00 for label  */
         if(strcmp(op[0],58)==0){byte=0x00;fwrite(&byte,1,1,rom);}

         if(strcmp(op[0],60)==0){ flag=0;  /* "<" half address */
         vp[0]=lines[l][1];vp[1]=lines[l][2];
         vp[2]=lines[l][3];
         for(a=0;a<intot;a++){        
         vt[0]=label[a][0];vt[1]=label[a][1];vt[2]=label[a][2];
         if((vp[0]==vt[0]) && (vp[1]==vt[1]) && (vp[2]==vt[2])){
         fwrite(&labad[a],1,1,rom);
         flag=1;}}
         if(flag != 1) {printf("ERROR: 1/2 ADDR NOT FOUND \n");}}       

         if(strcmp(op[0],62)==0){flag=0; /* ">" half address */
         vp[0]=lines[l][1];vp[1]=lines[l][2];
         vp[2]=lines[l][3];
         for(a=0;a<intot;a++){
         vt[0]=label[a][0];vt[1]=label[a][1];vt[2]=label[a][2];
         if((vp[0]==vt[0]) && (vp[1]==vt[1]) && (vp[2]==vt[2])){
         temp=((labad[a] >> 8) & 0xFF);
         fwrite(&temp,1,1,rom);flag=1;}} /* Top byte of address */
         if(flag != 1) {printf("ERROR: 1/2 ADDR NOT FOUND \n");}}

         if(strcmp(op,"NOP")==0){byte=0x00;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"LKP")==0){byte=0x42;fwrite(&byte,1,1,rom);}
         /* Previously "NOT" with special requiremnt for "B" reg */
         if(strcmp(op,"AND")==0){byte=0x40;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"ORR")==0){byte=0x41;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"INC")==0){byte=0x43;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"DEC")==0){byte=0x44;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"RLS")==0){byte=0x45;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"ADD")==0){byte=0x46;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"SUB")==0){byte=0x47;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"A>B")==0){byte=0x48;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"A=B")==0){byte=0x49;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"A<B")==0){byte=0x4A;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"MBA")==0){byte=0x4B;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"HCC")==0){byte=0x4C;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"AEZ")==0){byte=0x4D;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"OVF")==0){byte=0x4E;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"LLS")==0){byte=0x4F;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"KEY")==0){byte=0xB3;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"RKS")==0){byte=0xB8;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"RDS")==0){byte=0xB9;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"RRS")==0){byte=0xBA;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"IKS")==0){byte=0xC0;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"IDS")==0){byte=0xC1;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"IRS")==0){byte=0xC2;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"CHR")==0){byte=0xC3;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"DKS")==0){byte=0xC4;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"DDS")==0){byte=0xC5;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"DRS")==0){byte=0xC6;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"LCD")==0){byte=0xCB;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"WKS")==0){byte=0xCC;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"WDS")==0){byte=0xCD;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"WRS")==0){byte=0xCE;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"MAB")==0){byte=0x30;fwrite(&byte,1,1,rom);} 
         if(strcmp(op,"HEX")==0){byte=0x4C;fwrite(&byte,1,1,rom);}  
         if(strcmp(op,"ZKP")==0){byte=0xF0;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"KS0")==0){byte=0xE0;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"KS1")==0){byte=0xE1;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"KS2")==0){byte=0xE2;fwrite(&byte,1,1,rom);} 
         if(strcmp(op,"KS3")==0){byte=0xE3;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"KS4")==0){byte=0xE4;fwrite(&byte,1,1,rom);} 
         if(strcmp(op,"KS5")==0){byte=0xE5;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"KS6")==0){byte=0xE6;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"KS7")==0){byte=0xE7;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"KS8")==0){byte=0xE8;fwrite(&byte,1,1,rom);} 
         if(strcmp(op,"KS9")==0){byte=0xE9;fwrite(&byte,1,1,rom);} 
         if(strcmp(op,"KSA")==0){byte=0xEA;fwrite(&byte,1,1,rom);}
         if(strcmp(op,"KSB")==0){byte=0xEB;fwrite(&byte,1,1,rom);} 
         if(strcmp(op,"KSC")==0){byte=0xEC;fwrite(&byte,1,1,rom);} 
         if(strcmp(op,"KSD")==0){byte=0xED;fwrite(&byte,1,1,rom);}    
         if(strcmp(op,"KSE")==0){byte=0xEE;fwrite(&byte,1,1,rom);}  
         if(strcmp(op,"KSF")==0){byte=0xEF;fwrite(&byte,1,1,rom);}  

         /* List of operands requiring a single input constant */      
         if(strcmp(op,"DTA")==0){byte=0x70;fwrite(&byte,1,1,rom);
         if((lines[l+1][0] == 60) || (lines[l+1][0] == 62)) ;
                   else{      /*Do nothing here for "<" or ">" */ 
                   s[1]=lines[l+1][1];s[2]=lines[l+1][2];   
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}  
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;}
                   k=(16*m)+n;                   
                /* printf("The decimal number is %d \n", k); */
                   fwrite(&k,1,1,rom);}}           
   
         if(strcmp(op,"DTB")==0){byte=0x80;fwrite(&byte,1,1,rom);
                /* Note "<" or ">" can't be used with "DTB" */
                   s[1]=lines[l+1][1];s[2]=lines[l+1][2];   
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}  
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;}
                   k=(16*m)+n;                   
                /* printf("The decimal number is %d \n", k); */
                   fwrite(&k,1,1,rom);}   

          /* List of operands requiring two input constants */
         if(strcmp(op,"LDA")==0){byte=0x10;fwrite(&byte,1,1,rom);
                   if(lines[l+1][0] == 35){ flag=0; /* 35 is # */
                   vp[0]=lines[l+1][1];vp[1]=lines[l+1][2];
                   vp[2]=lines[l+1][3];
         for(a=0;a<intot;a++){
         vt[0]=varia[a][0];vt[1]=varia[a][1];vt[2]=varia[a][2];
         if((vp[0]==vt[0]) && (vp[1]==vt[1]) && (vp[2]==vt[2])){
         fwrite(&varad[a],2,1,rom);flag=1;}}
         if(flag != 1){printf("ERROR: VARIABLE NOT FOUND \n");}}
                   else{

                   s[1]=lines[l+1][1];s[2]=lines[l+1][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;}
                   k=(16*m)+n; fwrite(&k,1,1,rom);
                   s[1]=lines[l+2][1];s[2]=lines[l+2][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;} 
                   k=(16*m)+n; fwrite(&k,1,1,rom);}}      /* End of if */

          /* Another requiring two input constants */
         if(strcmp(op,"STA")==0){byte=0x20;fwrite(&byte,1,1,rom);

                   if(lines[l+1][0] == 35){ flag=0; /* 35 is # */
                   vp[0]=lines[l+1][1];vp[1]=lines[l+1][2];
                   vp[2]=lines[l+1][3];
         for(a=0;a<intot;a++){
         vt[0]=varia[a][0];vt[1]=varia[a][1];vt[2]=varia[a][2];
         if((vp[0]==vt[0]) && (vp[1]==vt[1]) && (vp[2]==vt[2])){
         fwrite(&varad[a],2,1,rom);flag=1;}}
         if(flag != 1){printf("ERROR: VARIABLE NOT FOUND \n");}}
                   else{

                   s[1]=lines[l+1][1];s[2]=lines[l+1][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;}
                   k=(16*m)+n; fwrite(&k,1,1,rom);
                   s[1]=lines[l+2][1];s[2]=lines[l+2][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;} 
                   k=(16*m)+n; fwrite(&k,1,1,rom);}}     /* End of if */

          /* List of operands requiring two input constants */
         if(strcmp(op,"JMP")==0){byte=0x50;fwrite(&byte,1,1,rom);

                   if(lines[l+1][0] == 42){ flag=0;
                   jp[0]=lines[l+1][1];jp[1]=lines[l+1][2];
                   jp[2]=lines[l+1][3];    
         for(a=0;a<intot;a++){
         jt[0]=label[a][0];jt[1]=label[a][1]; jt[2]=label[a][2];
         if((jp[0]==jt[0]) && (jp[1]==jt[1]) && (jp[2]==jt[2])){
         fwrite(&labad[a],2,1,rom);flag=1;}}
         if(flag != 1){printf("ERROR: LABEL NOT FOUND \n");}}
                   else{
                   s[1]=lines[l+1][1];s[2]=lines[l+1][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;}
                   k=(16*m)+n; fwrite(&k,1,1,rom);
                   s[1]=lines[l+2][1];s[2]=lines[l+2][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;} 
                   k=(16*m)+n; fwrite(&k,1,1,rom);}}     /* End of if */

          /* List of operands requiring two input constants */
         if(strcmp(op,"JGT")==0){byte=0x68;fwrite(&byte,1,1,rom);

                   if(lines[l+1][0] == 42){ flag=0;
                   jp[0]=lines[l+1][1];jp[1]=lines[l+1][2];
                   jp[2]=lines[l+1][3];
         for(a=0;a<intot;a++){
         jt[0]=label[a][0];jt[1]=label[a][1];jt[2]=label[a][2];
         if((jp[0]==jt[0]) && (jp[1]==jt[1]) && (jp[2]==jt[2])){
         fwrite(&labad[a],2,1,rom);flag=1;}}
         if(flag != 1){printf("ERROR: LABEL NOT FOUND \n");}}
                   else{

                   s[1]=lines[l+1][1];s[2]=lines[l+1][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;}
                   k=(16*m)+n; fwrite(&k,1,1,rom);
                   s[1]=lines[l+2][1];s[2]=lines[l+2][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;} 
                   k=(16*m)+n; fwrite(&k,1,1,rom);}}     /* End of if */

          /* List of operands requiring two input constants */
         if(strcmp(op,"JEQ")==0){byte=0x69;fwrite(&byte,1,1,rom);

                   if(lines[l+1][0] == 42){ flag=0;
                   jp[0]=lines[l+1][1];jp[1]=lines[l+1][2];
                   jp[2]=lines[l+1][3];
         for(a=0;a<intot;a++){
         jt[0]=label[a][0];jt[1]=label[a][1];jt[2]=label[a][2];
         if((jp[0]==jt[0]) && (jp[1]==jt[1]) && (jp[2]==jt[2])){
         fwrite(&labad[a],2,1,rom);flag=1;}}
         if(flag != 1){printf("ERROR: LABEL NOT FOUND \n");}}
                   else{

                   s[1]=lines[l+1][1];s[2]=lines[l+1][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;}
                   k=(16*m)+n; fwrite(&k,1,1,rom);
                   s[1]=lines[l+2][1];s[2]=lines[l+2][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;} 
                   k=(16*m)+n; fwrite(&k,1,1,rom);}}     /* End of if */

          /* List of operands requiring two input constants */
         if(strcmp(op,"JLT")==0){byte=0x6A;fwrite(&byte,1,1,rom);

                   if(lines[l+1][0] == 42){ flag=0;
                   jp[0]=lines[l+1][1];jp[1]=lines[l+1][2];
                   jp[2]=lines[l+1][3];
         for(a=0;a<intot;a++){
         jt[0]=label[a][0];jt[1]=label[a][1];jt[2]=label[a][2];
         if((jp[0]==jt[0]) && (jp[1]==jt[1]) && (jp[2]==jt[2])){  
         fwrite(&labad[a],2,1,rom);flag=1;}}
         if(flag != 1){printf("ERROR: LABEL NOT FOUND \n");}}
                   else{

                   s[1]=lines[l+1][1];s[2]=lines[l+1][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;}
                   k=(16*m)+n; fwrite(&k,1,1,rom);
                   s[1]=lines[l+2][1];s[2]=lines[l+2][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;} 
                   k=(16*m)+n; fwrite(&k,1,1,rom);}}     /* End of if */

          /* List of operands requiring two input constants */
         if(strcmp(op,"JAZ")==0){byte=0x6D;fwrite(&byte,1,1,rom);

                   if(lines[l+1][0] == 42){ flag=0;
                   jp[0]=lines[l+1][1];jp[1]=lines[l+1][2];
                   jp[2]=lines[l+1][3];
         for(a=0;a<intot;a++){
         jt[0]=label[a][0];jt[1]=label[a][1];jt[2]=label[a][2];
         if((jp[0]==jt[0]) && (jp[1]==jt[1]) && (jp[2]==jt[2])){
         fwrite(&labad[a],2,1,rom);flag=1;}}
         if(flag != 1){printf("ERROR: LABEL NOT FOUND \n");}}
                   else{

                   s[1]=lines[l+1][1];s[2]=lines[l+1][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;}
                   k=(16*m)+n; fwrite(&k,1,1,rom);
                   s[1]=lines[l+2][1];s[2]=lines[l+2][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;} 
                   k=(16*m)+n; fwrite(&k,1,1,rom);}}     /* End of if */

          /* List of operands requiring two input constants */
         if(strcmp(op,"JOV")==0){byte=0x6E;fwrite(&byte,1,1,rom);

                   if(lines[l+1][0] == 42){ flag=0;
                   jp[0]=lines[l+1][1];jp[1]=lines[l+1][2];
                   jp[2]=lines[l+1][3];
         for(a=0;a<intot;a++){
         jt[0]=label[a][0];jt[1]=label[a][1];jt[2]=label[a][2];
         if((jp[0]==jt[0]) && (jp[1]==jt[1]) && (jp[2]==jt[2])){
         fwrite(&labad[a],2,1,rom);flag=1;}}
         if(flag != 1){printf("ERROR: LABEL NOT FOUND \n");}}
                   else{

                   s[1]=lines[l+1][1];s[2]=lines[l+1][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;}
                   k=(16*m)+n; fwrite(&k,1,1,rom);
                   s[1]=lines[l+2][1];s[2]=lines[l+2][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;} 
                   k=(16*m)+n; fwrite(&k,1,1,rom);}}     /* End of if */

          /* List of operands requiring two input constants */
         if(strcmp(op,"LDB")==0){byte=0x90;fwrite(&byte,1,1,rom);

                   if(lines[l+1][0] == 35){ flag=0; /* 35 is # */
                   vp[0]=lines[l+1][1];vp[1]=lines[l+1][2];
                   vp[2]=lines[l+1][3];
         for(a=0;a<intot;a++){
         vt[0]=varia[a][0];vt[1]=varia[a][1];vt[2]=varia[a][2];
         if((vp[0]==vt[0]) && (vp[1]==vt[1]) && (vp[2]==vt[2])){
         fwrite(&varad[a],2,1,rom);flag=1;}}
         if(flag != 1){printf("ERROR: VARIABLE NOT FOUND \n");}}
                   else{

                   s[1]=lines[l+1][1];s[2]=lines[l+1][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;}
                   k=(16*m)+n; fwrite(&k,1,1,rom);
                   s[1]=lines[l+2][1];s[2]=lines[l+2][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;} 
                   k=(16*m)+n; fwrite(&k,1,1,rom);}}     /* End of if */

          /* List of operands requiring two input constants */
         if(strcmp(op,"STB")==0){byte=0xA0;fwrite(&byte,1,1,rom);

                   if(lines[l+1][0] == 35){ flag=0; /* 35 is # */
                   vp[0]=lines[l+1][1];vp[1]=lines[l+1][2];
                   vp[2]=lines[l+1][3];
         for(a=0;a<intot;a++){
         vt[0]=varia[a][0];vt[1]=varia[a][1];vt[2]=varia[a][2];
         if((vp[0]==vt[0]) && (vp[1]==vt[1]) && (vp[2]==vt[2])){
         fwrite(&varad[a],2,1,rom);flag=1;}}
         if(flag != 1){printf("ERROR: VARIABLE NOT FOUND \n");}}
                   else{

                   s[1]=lines[l+1][1];s[2]=lines[l+1][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;}
                   k=(16*m)+n; fwrite(&k,1,1,rom);
                   s[1]=lines[l+2][1];s[2]=lines[l+2][2]; /*Ignore x */
                   if(s[1]<58){m=s[1]-48;}else{m=s[1]-55;}
                   if(s[2]<58){n=s[2]-48;}else{n=s[2]-55;} 
                   k=(16*m)+n; fwrite(&k,1,1,rom);}}     /* End of if */

         if((byte==0xFF)&&(!((op[0]==120)||(op[0]==32)||(op[0]==60)|| 
         (op[0]==58) || (op[0]==42) || (op[0]==36) || (op[0]==35) ||   
         (op[0]==62) ))){
     /*  120 "x", 32 blank, 58 colon, 42 *, 36 $, 35 #, 60 <, 62 >  */    
         printf("MNEMONIC ERROR \n");}
         printf("op[0] is %d \n", op[0]); 
     /*  printf("pass \n");  */
         }
         printf("1st Label is %s at %d  \n", label[0], (labad[0]+1));
     /*  fwrite(&labad[0],2,1,rom);    Remove after testing! */
         printf("1st Variable is %s \n", varia[0]);     
     /*  fwrite(&varad[0],2,1,rom);    Remove after testing! */

         /* End of opcode string comparisons */
         putchar(lines[0][0]);   
         putchar(lines[0][1]);
         putchar(lines[0][2]);  
         putchar(lines[1][0]);  
         putchar(lines[1][1]);
         putchar(lines[1][2]);
         putchar(lines[2][0]);
         putchar(lines[2][1]);
         putchar(lines[2][2]);
         putchar(lines[3][0]); 
         putchar(lines[3][1]);
         putchar(lines[3][2]);
         putchar(lines[4][0]);
         putchar(lines[4][1]); 
         putchar(lines[4][2]);  
         putchar(lines[5][0]); 
         putchar(lines[5][1]); 
         putchar(lines[5][2]);
         putchar(lines[6][0]);  
         putchar(lines[6][1]);   
         putchar(lines[6][2]); 
         fcloseall;
}
        /* End of Listing */